-- Title: Pet Battle FF Victory
-- Author: LownIgnitus
-- Version: 1.1.0
-- Desc: A simple addon to change the victory sound for pet battles
-- Added Functionality to play fail sound and toggle its use

--Version Information
local Title = "|cff00ff00Pet Battle FF Victory|r"
local Core = "|cffFF45001|r"
local Revision = "|cffFF45001|r"
local Build = "|cffFF45000|r"

--slash commands
SLASH_PBFFV1 = '/pbffv'

-- Frame Definitions
local pbffvFrame = CreateFrame("Frame")

-- on load events
function PBFFVOnLoad()
	--print("In On Load!")
	RegisterPetBattleEndEvent()

	if not failState then
		failState = "enable"
	end

	if failState == "disabled" then
		FailToggle(failState)
	end
end

-- catch functions
function RegisterPetBattleEndEvent()
	--print("In Register!")
	pbffvFrame:RegisterEvent("PET_BATTLE_OVER")
	pbffvFrame:RegisterEvent("PET_BATTLE_FINAL_ROUND")
	pbffvFrame:SetScript("OnEvent", PBFFVFINALROUND)
end

-- Print version info and slash commands
function SlashCmdList.PBFFV(msg)
	if msg == "victory" then
		Victory()
	else if msg == "fail play" then
		Fail()
	else if msg == "fail" then
		if failState == "enable" then
			failState = "disabled"
			print("|cffff0000Fail sound is off|r!")
		elseif failState == "disabled" then
			failState = "enable"
			print("|cff00ff00Fail sound is on|r!")
		end
	else
		print("Thank you for using " .. Title)
		print("Version: " .. Core .. "." .. Revision .. "." .. Build)
		print("Author:  |cffDA70D6LownIgnitus|r")
		print("Slash commands are listed below to follow /pbffv:")
		print("  -- victory play -- Plays the FF Victory sound file.")
		print("  -- fail play -- Plays the Price is Right Fail Horn.")
		print("  -- fail -- Toggles fail sound on/off.")
		--print("  -- i -- i.")
	end
end
end
end

-- play victory sound
function Victory()
	StopMusic();
	PlaySoundFile("Interface\\AddOns\\petbattleffvictory\\Music\\Victory.ogg")
	print("|cff00ff00Victory!|r")
end

-- play Fail Sound
function Fail()
	StopMusic();
	PlaySoundFile("Interface\\AddOns\\petbattleffvictory\\Music\\FailHorn.ogg")
	print("|cffff0000Fail....|r")
end

-- detect end battle and pass to victory
function PBFFVFINALROUND(self,event,outcomenumber)
	if event == "PET_BATTLE_FINAL_ROUND" then
		--print("FailState: ", failState)
		--print("Outcomenumber: ", outcomenumber)
		StopMusic();
		if outcomenumber == 1 then
			--print("1")
			Victory()
		end
		if outcomenumber == 2 then 
			--print("2")
			if failState == "enable" then
				Fail()
			end
		end
	end
end

--initialize
PBFFVOnLoad()
print(Title .. " Version: " .. Core .. "." .. Revision .. "." .. Build .. " has been loaded!")
print("|cff00ff00/pbffv|r to access slash command list.")